<section class="actions">
  <input type="file" #upload style="display: none" (change)="uploadFiles(upload)">

  <button mat-icon-button matTooltip="Hochladen" class="action" (click)="upload.click()">
    <mat-icon>file_upload</mat-icon>
  </button>

  <button mat-icon-button matTooltip="Übergeortneter Ordner" class="action" (click)="changeDir(getUpFolder())" (dragover)="onDragUpOver($event)" (drop)="onDropUp($event, getUpFolder())">
    <mat-icon>drive_folder_upload</mat-icon>
  </button>

  <button mat-icon-button matTooltip="Ordner erstellen" class="action" (click)="properties.dialog.toggle(addDirectory, true)">
    <mat-icon>create_new_folder</mat-icon>
  </button>

  <form class="directory input" (submit)="$event.preventDefault(); directory.blur(); changeDir(directory.value)">
    <mat-icon>folder</mat-icon>
    <input type="text" [value]="currentDirectory" #directory>
  </form>

  <form class="search input" (submit)="$event.preventDefault(); search.blur(); searchFiles(search.value)">
    <mat-icon>search</mat-icon>
    <input type="text" placeholder="Suche" #search>
  </form>

  <mat-progress-bar mode="determinate" value="{{progress}}"></mat-progress-bar>
</section>

<main class="directory-content" #content (mousedown)="currentItem = undefined">
  <div class="content"
      *ngFor="let directory of currentDirectoryInfo?.directories"
      (dblclick)="changeDir(currentDirectory + directory + '/')"
      (click)="selectItem(self, directory, true)"
      (dragover)="onDragOver($event, directory)" (dragstart)="onDrag(directory, true)" (drop)="onDrop($event, directory)"
      #self draggable="true">

    <mat-icon class="icon">folder</mat-icon>
    <span>{{directory}}</span>
    <button mat-icon-button (click)="deleteItem(directory)"><mat-icon>delete</mat-icon></button>
  </div>

  <div class="content"
       *ngFor="let file of currentDirectoryInfo?.files"
       (dblclick)="openWith(file)"
       (click)="selectItem(self, file, false)"
       (dragstart)="onDrag(file, false)"
       #self draggable="true">

    <mat-icon class="icon">{{getFileImage(file)}}</mat-icon>
    <span>{{file}}</span>

    <button mat-icon-button (click)="openWith(file)"><mat-icon>open_in_new</mat-icon></button>
    <button mat-icon-button (click)="downloadFile(file)"><mat-icon>file_download</mat-icon></button>
    <button mat-icon-button (click)="deleteItem(file)"><mat-icon>delete</mat-icon></button>
  </div>
</main>


<form *ngIf="nameBarOptions.enabled" class="name-bar" (submit)="$event.preventDefault(); onSave(currentDirectory + nameBar.value)">
  <div class="input">
    <mat-icon>insert_drive_file</mat-icon>
    <input type="text" [value]="nameBarOptions.value" (change)="nameBarOptions.value = nameBar.value" autofocus #nameBar>
  </div>

  <button mat-icon-button>
    <mat-icon *ngIf="nameBarOptions.type == 'save-file'">save</mat-icon>
    <mat-icon *ngIf="nameBarOptions.type != 'save-file'">open_in_new</mat-icon>
  </button>
</form>

<section class="directory-information" *ngIf="currentDirectoryInformation !== undefined">
  <span>{{currentDirectoryInfo?.files.length + currentDirectoryInfo?.directories.length}} Elemente</span>
  <span>Größe: {{humanFileSize(currentDirectoryInformation?.size)}}</span>
  <span>Erstellt: {{currentDirectoryInformation?.created.toLocaleString()}}</span>
</section>

<form class="dialog create-directory" #addDirectory (reset)="properties.dialog.toggle(addDirectory, false)" (submit)="$event.preventDefault(); createDirectory(label.value); properties.dialog.toggle(addDirectory, false); addDirectory.reset()">
  <mat-form-field appearance="fill">
    <mat-label>Name</mat-label>
    <input matInput required #label>
  </mat-form-field>

  <div class="buttons">
    <button mat-raised-button color="primary" type="submit">Erstellen</button>
    <button mat-raised-button color="warn" type="reset">Abbrechen</button>
  </div>
</form>

<form class="dialog override" #override (reset)="properties.dialog.toggle(override, false)" (submit)="onSave(currentDirectory + nameBarOptions.value, true)">
  <span>Möchtest du dieses Element überschreiben?</span>

  <div class="buttons">
    <button mat-raised-button color="primary" type="submit">Ja</button>
    <button mat-raised-button color="warn" type="reset">Nein</button>
  </div>
</form>

<form class="dialog select-program unselectable" #selectProgram (submit)="$event.preventDefault();">
  <div class="buttons-right">
    <button mat-icon-button (click)="properties.dialog.toggle(selectProgram, false)"><mat-icon>close</mat-icon></button>
  </div>

  <div class="program" *ngFor="let program of openPrograms" (click)="openProgram(program); properties.dialog.toggle(selectProgram, false)">
    <img src="{{program.icon}}" alt="{{program.id}}">
    <span>{{program.name}}</span>
  </div>
</form>
